import wx
import random
import wx.lib.scrolledpanel as scrolled
import wx.html

import ColorPanel
import GridSimple
import ListCtrl
import ScrolledWindow

import NotebookCtrl as NC

ArtIDs = [ "wx.ART_ADD_BOOKMARK",
           "wx.ART_DEL_BOOKMARK",
           "wx.ART_HELP_SIDE_PANEL",
           "wx.ART_HELP_SETTINGS",
           "wx.ART_HELP_BOOK",
           "wx.ART_HELP_FOLDER",
           "wx.ART_HELP_PAGE",
           "wx.ART_GO_BACK",
           "wx.ART_GO_FORWARD",
           "wx.ART_GO_UP",
           "wx.ART_GO_DOWN",
           "wx.ART_GO_TO_PARENT",
           "wx.ART_GO_HOME",
           "wx.ART_FILE_OPEN",
           "wx.ART_PRINT",
           "wx.ART_HELP",
           "wx.ART_TIP",
           "wx.ART_REPORT_VIEW",
           "wx.ART_LIST_VIEW",
           "wx.ART_NEW_DIR",
           "wx.ART_HARDDISK",
           "wx.ART_FLOPPY",
           "wx.ART_CDROM",
           "wx.ART_REMOVABLE",
           "wx.ART_FOLDER",
           "wx.ART_FOLDER_OPEN",
           "wx.ART_GO_DIR_UP",
           "wx.ART_EXECUTABLE_FILE",
           "wx.ART_NORMAL_FILE",
           "wx.ART_TICK_MARK",
           "wx.ART_CROSS_MARK",
           "wx.ART_ERROR",
           "wx.ART_QUESTION",
           "wx.ART_WARNING",
           "wx.ART_INFORMATION",
           "wx.ART_MISSING_IMAGE",
           ]

if wx.Platform == '__WXMAC__':
    DEFAULT_SIZE = wx.Size(26, 26)
else:
    DEFAULT_SIZE = wx.DefaultSize


htmlhelp = """<html><body>
<h2>NotebookCtrl</h2>

NotebookCtrl Mimics The Behavior Of wx.Notebook, And Most Of Its Functionalities
Are Implemented In NotebookCtrl. However, NotebookCtrl Has A Lot Of Options That
wx.Notebook Does Not Have, And It Is Therefore Quite Customizable.
<p>wx.Notebook Styles Not Implemented in NotebookCtrl Are:

- wx.NB_LEFT
- wx.NB_RIGHT
- wx.NB_MULTILINE (But NotebookCtrl Has A SpinButton To Navigate Through Tabs).

Supported Customizations For NotebookCtrl Include:

* Setting Individual Tab Font And Text Colour;
* Images On Tabs (Like wx.Notebook);
* Setting Individual Tab Colours;
* Disabling/Enabling Individual Tabs (Also Visually Effective); Now Supports Grayed Out Icons When A Page Is Disabled;
* Drawing Of A Small Closing "X" At The Right Of Every Tab, That Enable The User To Close A Tab With A Mouse Click (Like eMule Tab Style);
* Enabling Highlighted Tabs On Selection;
* Drawing Focus Indicator In Each Tab (Like wx.Notebook);
* Ctrl-Tab Keyboard Navigation Between Pages;
* Tab With Animated Icons (Animation On Tabs);
* Drag And Drop Tabs In NotebookCtrl (Plus A Visual Arrow Effect To Indicate Dropping Position);
* Drag And Drop Event;
* ToolTips On Individual Tabs, With Customizable ToolTip Time Popup And ToolTip Window Size For Individual Tabs;
* Possibility To Hide The TabCtrl There Is Only One Tab (Thus Maximizing The Corresponding Window);
* Possibility To Convert The Tab Image Into A Close Button While Mouse Is Hovering On The Tab Image;
* Popup Menus On Tabs (Popup Menus Specific To Each Tab);
* Showing Pages In "Column/Row Mode", Which Means That All Pages Will Be Shown In NotebookCtrl While The Tabs Are Hidden. They Can Be Shown In Columns (Default) Or In Rows;
* Possibility To Hide Tabs On User Request, Thus Showing Only The Current Panel;
* Multiple Tabs Selection (Hold Ctrl Key Down And Left Mouse Click), Useful When You Use The Show All The Panels In Columns/Rows. In This Case, Only The Selected Tabs Are Shown In Columns/Rows;
* Events For Mouse Events (Left Double Click, Middle Click, Right Click);
* Possibility To Reparent A NotebookCtrl Page To A Freshly Created Frame As A Simple Panel Or To A New NotebookCtrl Created Inside That New Frame.
* Possibility To Add A Custom Panel To Show A Logo Or HTML Information Or Whatever You Like When There Are No Tabs In NotebookCtrl;
* Possibility To Change The ToolTip Window Background Colour;
* Possibility To Draw Vertical Or Horizontal Gradient Coloured Tabs (2 Colours);
* Themes On Tabs: Built-In Themes Are KDE (Unix/Linux), Metal, Aqua Light And Aqua Dark (MacOS), Windows Silver (Windows) Or Generic Gradient Coloured Tabs. It's Also Possible To Define A Separate Theme For Selected Tabs And Control Background;
* Contour Line Colour Around Tabs Is Customizable;
* Highlight Colour Of Selected Tab Is Customizable;
* Each Tab Can Have Its Own Gradient Colouring (2 Colours For Every Tab);
* Custom Images May Be Drawn As A "X" Close Buttons On Tabs;
* Possibility To Hide A Particular Tab Using A wx.PopupMenu That Is Shown If You Call EnableHiding(True). Look At The Top Right Of NotebookCtrl;
* Allows Drag And Drop Of Tabs/Pages Between Different NotebookCtrls In The Same Application.
* Draw tabs on the left or right side, rotated or horizontal
* Allow user to switch between rotated and horizontal displays of tabs on the left or right side.

<p>Usage:

NotebookCtrl Construction Is Quite Similar To wx.Notebook:

NotebookCtrl.__init__(self, parent, id, pos=wx.DefaultPosition,
                      size=wx.DefaultSize, style=style, sizer=nbsizer)

See NotebookCtrl __init__() Method For The Definition Of Non Standard (Non
wxPython) Parameters.

<p><p>NotebookCtrl Control Is Freeware And Distributed Under The wxPython License. 

Latest Revision: Andrea Gavana @ 06 Oct 2006, 18.10 GMT

<p>Credits:

For the big improvements, the very nice functionalities added and the great refactoring
of NotebookCtrl, my thanks goes to Julianne Sharer that has done an excellent and huge
work to improve this widget to almost perfection.

Between All The Nice Posters In The wxPython Newsgroup That Have Suggested Very
Interesting Improvemets, Bug Reports And New Features, I Would Like To Thanks Stani,
The <a href="http://www.stani.be/python/spe/blog/"></a>SPE Author.

<p>Contacts:

For Every Suggestion, Bug Report Or Request Of New Features, Please Contact Me At:

<a href="mailto:andrea.gavana@gmail.com"></a>andrea.gavana@gmail.com
<a href="mailto:gavana@kpo.kz"></a>gavana@kpo.kz

"""
    
#----------------------------------------------------------------------
def GetMondrianData():
    return \
'\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00 \x00\x00\x00 \x08\x06\x00\
\x00\x00szz\xf4\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\x00\x00qID\
ATX\x85\xed\xd6;\n\x800\x10E\xd1{\xc5\x8d\xb9r\x97\x16\x0b\xad$\x8a\x82:\x16\
o\xda\x84pB2\x1f\x81Fa\x8c\x9c\x08\x04Z{\xcf\xa72\xbcv\xfa\xc5\x08 \x80r\x80\
\xfc\xa2\x0e\x1c\xe4\xba\xfaX\x1d\xd0\xde]S\x07\x02\xd8>\xe1wa-`\x9fQ\xe9\
\x86\x01\x04\x10\x00\\(Dk\x1b-\x04\xdc\x1d\x07\x14\x98;\x0bS\x7f\x7f\xf9\x13\
\x04\x10@\xf9X\xbe\x00\xc9 \x14K\xc1<={\x00\x00\x00\x00IEND\xaeB`\x82' 

def GetMondrianBitmap():
    return wx.BitmapFromImage(GetMondrianImage())

def GetMondrianImage():
    import cStringIO
    stream = cStringIO.StringIO(GetMondrianData())
    return wx.ImageFromStream(stream)

def GetMondrianIcon():
    icon = wx.EmptyIcon()
    icon.CopyFromBitmap(GetMondrianBitmap())
    return icon


#----------------------------------------------------------------------
def GetSmilesData():
    return \
'\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x10\x08\x06\
\x00\x00\x00\x1f\xf3\xffa\x00\x00\x00\x04sBIT\x08\x08\x08\x08|\x08d\x88\x00\
\x00\x02\x89IDAT8\x8dm\x93\xddK\x93a\x18\xc6\x7f\xef\xc7\xb3\xa6\xc3 aV\xcc\
\xad\x99\x8d\\\x08\x11AAd\x91\x95\x85F\'\x9dD\x8d\xa8\xe9\xb6X\x87\xe1\x7f\
\xd0A\xe2y\'\xe6I\x7f@\'!T\x96\'A\x10A\xf4!\xcc\xd1\xb7&DP \xba\xe5\xde\xd7\
\xed\xea\xc0\xcdF\xf9\xc0u\xf2<\xcf\xc5}\xdf\xd7u\xddX\xb6\xc3\xbfH\xa5.)\
\x1e\xdf)\xd7\xb5d\x8c\xadD"\xaa\\.\xa3\xcd\xfe\xda4\x9dl&\xad\xceHP\xbd\xbd\
\x9fx\xf0\xe0\x08\xe5\xf2eJ\xa5\x8b\xdc\xbf\xbf\x9f\xae\xaeGtFj\xcaf\xae\xa9\
\x99cY\xb6\x03\xc0\xe9S\xc7\x14\x8b\xfd\xe4\xce\x9d\xf3\x18\xe3\x01%`\x05\
\xa8\x02\x15\xe0#\xbe_ \x9f\xf7\x98\x9f?\xc2\xf4\x93\xe7\x16\xb0\xdeA6\x93V,\
\x06\x13\x13\xb71&\t\x84\xea\xc4F\xb1U\xa0\x8c1\x16\x13\x13[\x88\xc5\x9e\x91\
\xcd\\]\x7f\xb4l\x87h\xb4]\x9eW\x90\xf4E\xd2c\x8d\x8e\x8e\n\x90\x94\x92\x94\
\x12\xa0p8,\xa9UR\x8b<\x0fE;\x91e;\xb8\xd9LZ]]k\x18\xd3\x028@\x8d\xf1\xf1\
\xf1\xa6)\x97\xe8\xe9\xe9ann\x0eh\x05\xd50\x04\xb9q\xbd\xca\xe7\xf9\x94\xec\
\x99\x99\x87\x0c\rE\x80E\xe0#\xf0\xba\x89\\\x01\x16YXXh\xba\xabA\xa5\x95\xa1\
\x93m\xcc\xccLa\x19c\xabT\xba\x891m\xc0*\xc3\xc3\xdf\x99\x9c\xf46\x84\x83\
\x85\xba\xa0ur\xb5\nK\x1d\xf8\xab\x0e\xa1]\xf3\r\x1b\xbd\xba\xe2\xcbLN\xfa\
\xc0\x12\xf0\x0e(6\x91\x05Zcwg\x10\xfc\x16\xf0\x83\x00\xd8\xf1x\x84b\xf1\x1b\
\xf0\x03(\x92L\xbe\x04^\xd4+\xeb/\x19\x1f\xaa6\x9f\xbf/C\xb9\x8d\xe2\x9cE|W\
\x18\xb7\xbf\xff\x0cSS\xf7\xe8\xed\r\x00\xa2P\x80PH\x94\x1a\x85\xa9\x01kP\
\xb58\xb8\xaf\r}\x89@y+S\x8f\x7f\xd1\x7f\xfcd\xc3FK\x9e\xd7R\xb7i\xdd*\x05\
\x83\n\x04\x02r]G\xa1\xa0\xab\xfd\xdd\xed\xd2\xe2^\xa9\xd0\'\xef\xd5\tEw\x04\
\xb4\x11\xe5\xc1\xc14\xf9\xfc\xeaz\x9b\r\xfc\xf6\xa9\xf8>\xbecq8\xd9\xc1\xeb\
\xa7QX\x0e\xc3Z\x80\xfc\xad"\x83g\xce\xb1\x11$\xcbv\x18\x18\xe8\xd3\xc8\x08\
\xf2<$\xd5Q\xb5\xa5\x95m\xd2\xb7\xa4\xf4\xe1\x90\xbc7G5ra\x87\x06\x8e\x1f\
\xd0\x7f\xcb4\xfd\xe4\xb9\xe58\xc3tw\xc3\xd8\x18\xcc\xce\x82_q\xf0+6\xb3\xef\
W\x18\xbb\xfb\x95\xee\xb3/p\xb6\xf61\xfd\xec\xad\xb5\x11\x8b\xcdV4\x97K+\x91\
\xd8.\xe3"\xe3\xa2\xc4\x9e\x0e\xe52W6]\xe7?\xc6#-\xf1\x056\x98<\x00\x00\x00\
\x00IEND\xaeB`\x82' 

def GetSmilesBitmap():
    return wx.BitmapFromImage(GetSmilesImage())

def GetSmilesImage():
    import cStringIO
    stream = cStringIO.StringIO(GetSmilesData())
    return wx.ImageFromStream(stream)


class NotebookCtrlDemo(wx.Frame):

    def __init__(self, parent, id=wx.ID_ANY, title="", pos=wx.DefaultPosition,
                 size=wx.Size(20,20), style=wx.DEFAULT_FRAME_STYLE | wx.CLIP_CHILDREN |
                 wx.NO_FULL_REPAINT_ON_RESIZE):

        wx.Frame.__init__(self, parent, id, title, pos, size, style)

        self.SetIcon(GetMondrianIcon())

        self.statusbar = self.CreateStatusBar(2, wx.ST_SIZEGRIP)
        self.statusbar.SetStatusWidths([-2, -1])
        # statusbar fields
        statusbar_fields = [("NotebookCtrl Demo, Andrea Gavana @ 11 Nov 2005"),
                            ("Welcome To wxPython!")]

        for i in range(len(statusbar_fields)):
            self.statusbar.SetStatusText(statusbar_fields[i], i)
            
        self.SetMenuBar(self.CreateMenuBar())

        self.standardfont = wx.SystemSettings_GetFont(wx.SYS_DEFAULT_GUI_FONT)
        self.textcolour = [None, wx.NamedColor("Salmon"), wx.BLUE, wx.RED, wx.GREEN,
                           wx.NamedColor("Orange"), wx.NamedColor("purple"),
                           wx.BLUE, None]

        self.pagecolours = [wx.NamedColor("Cyan"), wx.BLUE, wx.NamedColor("Yellow"), wx.WHITE,
                            wx.NamedColor("Orange"), wx.GREEN, wx.SystemSettings_GetColour(wx.SYS_COLOUR_BTNFACE),
                            wx.WHITE, wx.RED]     
        
        self.tooltips = ["This Is My ToolTip!",
                         "Welcome To wxPython! If You Like\nNotebookCtrl, Please Let Me Know!",
                         "For Any Bug Reports Or Feature Requests,\nPlease Send An E-mail To:\n\n"\
                         "andrea.gavana@agip.it\n\nOr\n\nandrea_gavana@tin.it\n", "",
                         "Your wxPython Version Is:\n" + wx.VERSION_STRING,
                         "", "This Is Another Useful TooTip...", "", "Hello from wxPython"]
        
        splitter = wx.SplitterWindow(self, -1, style=wx.CLIP_CHILDREN | wx.SP_3D)
        splitter2 = wx.SplitterWindow(splitter, -1, style=wx.CLIP_CHILDREN | wx.SP_3D)        

        self.leftpanel = scrolled.ScrolledPanel(splitter, -1)

        self.PopulateLeftPanel()        
        
        self.panel = wx.Panel(splitter2, -1)
    
        self.mainsizer = wx.BoxSizer(wx.VERTICAL)
        self.panel.SetSizer(self.mainsizer)
        self.mainsizer.Layout()

        self.tabstyle = NC.ThemeStyle()        
        
        self.RecreateNotebook()

        # Set up a log window
        self.log = wx.TextCtrl(splitter2, -1,
                               style = wx.TE_MULTILINE|wx.TE_READONLY|wx.HSCROLL)

        # But instead of the above we want to show how to use our own wx.Log class
        wx.Log_SetActiveTarget(MyLog(self.log))
        
        # add the windows to the splitter and split it.
        splitter2.SplitHorizontally(self.panel, self.log, -120)
        splitter.SplitVertically(self.leftpanel, splitter2, 240)

        splitter.SetMinimumPaneSize(140)
        splitter2.SetMinimumPaneSize(60)

        # Make the splitter on the right expand the top window when resized
        def SplitterOnSize(evt):
            splitter = evt.GetEventObject()
            sz = splitter.GetSize()
            splitter.SetSashPosition(sz.height - 120, False)
            evt.Skip()

        splitter2.Bind(wx.EVT_SIZE, SplitterOnSize)

        self.leftpanel.SetupScrolling()
        self.SetMinSize((680,480))


    def PopulateLeftPanel(self):

        stylesizer_staticbox = wx.StaticBox(self.leftpanel, -1, "Notebook Styles")
        sizersizer_staticbox = wx.StaticBox(self.leftpanel, -1, "Notebook Sizer Styles")
        textsizer_staticbox = wx.StaticBox(self.leftpanel, -1, "Text Styles")
        tabssizer_staticbox = wx.StaticBox(self.leftpanel, -1, "Tabs Styles")
        style_staticbox = wx.StaticBox(self.leftpanel, -1, "Tabs Themes")
        animationsizer_staticbox = wx.StaticBox(self.leftpanel, -1, "Tabs Animation")
        tooltipsizer_staticbox = wx.StaticBox(self.leftpanel, -1, "Tabs ToolTips")
        actionsizer_staticbox = wx.StaticBox(self.leftpanel, -1, "Notebook Actions")
        reparent_staticbox = wx.StaticBox(self.leftpanel, -1, "Reparent Options")
        custom_staticbox = wx.StaticBox(self.leftpanel, -1, "Custom Panel Addition")
        self.addpage = wx.Button(self.leftpanel, -1, "Add Page")
        self.insertpage = wx.Button(self.leftpanel, -1, "Insert Page")
        self.pageinserted = wx.TextCtrl(self.leftpanel, -1, "")
        self.deletepage = wx.Button(self.leftpanel, -1, "Delete Page")
        self.pagedeleted = wx.TextCtrl(self.leftpanel, -1, "")
        self.deleteall = wx.Button(self.leftpanel, -1, "Delete All Pages")
        self.defaultpage = wx.Button(self.leftpanel, -1, "Default Page")
        self.pagedefault = wx.TextCtrl(self.leftpanel, -1, "")
        self.recreate = wx.Button(self.leftpanel, -1, "Recreate Notebook")
        self.nc_top = wx.RadioButton(self.leftpanel, -1, "NC_TOP", style=wx.RB_GROUP)
        self.nc_bottom = wx.RadioButton(self.leftpanel, -1, "NC_BOTTOM")
        self.nc_left = wx.RadioButton(self.leftpanel, -1, "NC_LEFT")
        self.nc_right = wx.RadioButton(self.leftpanel, -1, "NC_RIGHT")
        self.fixedwidth = wx.CheckBox(self.leftpanel, -1, "NC_FIXED_WIDTH")
        self.rotate = wx.CheckBox(self.leftpanel, -1, "NC_ROTATE")
        self.expandable = wx.CheckBox(self.leftpanel, -1, "NC_EXPANDABLE")
        self.sizerh = wx.RadioButton(self.leftpanel, -1, "Horizontal (Default)", style=wx.RB_GROUP)
        self.sizerv = wx.RadioButton(self.leftpanel, -1, "Vertical")
        self.fontcolour = wx.CheckBox(self.leftpanel, -1, "Font And Colour Capabilities")
        self.tabimages = wx.CheckBox(self.leftpanel, -1, "Show Images On Tabs")
        self.colourtabs = wx.CheckBox(self.leftpanel, -1, "Colour Tabs")
        self.disabletab = wx.CheckBox(self.leftpanel, -1, "Show A Disabled Tab")
        self.drawx = wx.CheckBox(self.leftpanel, -1, "Draw Small Closing \"X\"")
        self.xemulestyle = wx.RadioButton(self.leftpanel, -1, "eMule \"X\" Style", style=wx.RB_GROUP)
        self.xoperastyle = wx.RadioButton(self.leftpanel, -1, "Opera \"X\" Style")
        self.ximagestyle = wx.RadioButton(self.leftpanel, -1, "Use Image \"X\" Style")
        self.highlight = wx.CheckBox(self.leftpanel, -1, "Highlight On Selection")
        self.focusindicator = wx.CheckBox(self.leftpanel, -1, "Use Focus Indicator")
        self.convertimage = wx.CheckBox(self.leftpanel, -1, "Convert Image To Close Button")
        self.hideonsingle = wx.CheckBox(self.leftpanel, -1, "Hide TabCtrl If Only One Tab")
        self.enablepopup = wx.CheckBox(self.leftpanel, -1, "Enable Popup Menu On Tabs")
        self.tiling = wx.CheckBox(self.leftpanel, -1, "Enable Page Tiling")
        self.showcolumns = wx.RadioButton(self.leftpanel, -1, "Tile Pages Horizontally", style=wx.RB_GROUP)
        self.showrows = wx.RadioButton(self.leftpanel, -1, "Tile Pages Vertically")
        self.showtabs = wx.CheckBox(self.leftpanel, -1, "Hide NotebookCtrl Tabs")
        self.hidetabs = wx.CheckBox(self.leftpanel, -1, "Hide Selected Tabs With Menu")

        self.wintabs = wx.CheckBox(self.leftpanel, -1, "Draw Windows Theme")
        self.unixtabs = wx.CheckBox(self.leftpanel, -1, "Draw Unix KDE Themes")
        self.mactabs = wx.CheckBox(self.leftpanel, -1, "Draw Mac Themes")
        self.gradtabs = wx.CheckBox(self.leftpanel, -1, "Draw Gradient Coloured Tabs")
        self.mac1 = wx.RadioButton(self.leftpanel, -1, "Aqua Light Theme", style=wx.RB_GROUP)
        self.mac2 = wx.RadioButton(self.leftpanel, -1, "Aqua Dark Theme")
        self.mac3 = wx.RadioButton(self.leftpanel, -1, "Metal Theme")
        self.col1 = wx.Button(self.leftpanel, -1, "1st Colour", size=(-1, 15))
        self.col2 = wx.Button(self.leftpanel, -1, "2nd Colour", size=(-1, 15))
        self.gradv = wx.RadioButton(self.leftpanel, -1, "Vertical Gradient", style=wx.RB_GROUP)
        self.gradh = wx.RadioButton(self.leftpanel, -1, "Horizontal Gradient")
        self.singlegrad = wx.CheckBox(self.leftpanel, -1, "Each Tab Has Its Own Gradient")
        
        self.animate = wx.CheckBox(self.leftpanel, -1, "Animate Tab Images")
        self.draganddrop = wx.CheckBox(self.leftpanel, -1, "Enable Drag And Drop")
        self.showtooltip = wx.CheckBox(self.leftpanel, -1, "Show Tabs ToolTips")
        self.enablerep = wx.CheckBox(self.leftpanel, -1, "Enable Reparenting")
        self.framerep = wx.RadioButton(self.leftpanel, -1, "Reparent As Simple Panel", style=wx.RB_GROUP)
        self.nbrep = wx.RadioButton(self.leftpanel, -1, "Reparent As NotebookCtrl")
        self.custom = wx.CheckBox(self.leftpanel, -1, "Add Custom Panel")
        self.customimage = wx.RadioButton(self.leftpanel, -1, "Panel With Logo", style=wx.RB_GROUP)
        self.customhtml = wx.RadioButton(self.leftpanel, -1, "HTML Page With Info")

        self.nc_top.SetValue(1)
        self.sizerh.SetValue(1)
        self.focusindicator.SetValue(1)
        self.xemulestyle.Enable(False)
        self.xoperastyle.Enable(False)
        self.ximagestyle.Enable(False)
        self.framerep.Enable(False)
        self.nbrep.Enable(False)
        self.showcolumns.Enable(False)
        self.showrows.Enable(False)
        self.customimage.Enable(False)
        self.customhtml.Enable(False)
        self.mac1.Enable(False)
        self.mac2.Enable(False)
        self.mac3.Enable(False)
        self.col1.Enable(False)
        self.col2.Enable(False)
        self.col1.SetBackgroundColour(wx.WHITE)
        self.gradv.Enable(False)
        self.gradh.Enable(False)
        
        color = self.GetBackgroundColour()
        r, g, b = int(color.Red()), int(color.Green()), int(color.Blue())
        color = ((r >> 1) + 20, (g >> 1) + 20, (b >> 1) + 20)
        colour = wx.Colour(color[0], color[1], color[2])
        self.col2.SetBackgroundColour(colour)
            
        leftpanelsizer = wx.BoxSizer(wx.VERTICAL)
        tooltipsizer = wx.StaticBoxSizer(tooltipsizer_staticbox, wx.VERTICAL)
        animationsizer = wx.StaticBoxSizer(animationsizer_staticbox, wx.VERTICAL)
        tabssizer = wx.StaticBoxSizer(tabssizer_staticbox, wx.VERTICAL)
        stylesizer2 = wx.StaticBoxSizer(style_staticbox, wx.VERTICAL)
        xsizer = wx.BoxSizer(wx.VERTICAL)
        xsizer2 = wx.BoxSizer(wx.VERTICAL)
        xsizer3 = wx.BoxSizer(wx.VERTICAL)
        xsizer4 = wx.BoxSizer(wx.VERTICAL)
        xsizer5 = wx.BoxSizer(wx.VERTICAL)
        xsizer6 = wx.BoxSizer(wx.VERTICAL)
        xsizer7 = wx.BoxSizer(wx.VERTICAL)
        sizerh1 = wx.BoxSizer(wx.HORIZONTAL)
        textsizer = wx.StaticBoxSizer(textsizer_staticbox, wx.VERTICAL)
        stylesizer = wx.StaticBoxSizer(stylesizer_staticbox, wx.VERTICAL)
        sizersizer = wx.StaticBoxSizer(sizersizer_staticbox, wx.VERTICAL)
        actionsizer = wx.StaticBoxSizer(actionsizer_staticbox, wx.VERTICAL)
        reparentsizer = wx.StaticBoxSizer(reparent_staticbox, wx.VERTICAL)
        customsizer = wx.StaticBoxSizer(custom_staticbox, wx.VERTICAL)
        recreatesizer = wx.BoxSizer(wx.HORIZONTAL)
        deletesizer = wx.BoxSizer(wx.HORIZONTAL)
        insertsizer = wx.BoxSizer(wx.HORIZONTAL)
        defaultsizer = wx.BoxSizer(wx.HORIZONTAL)
        
        actionsizer.Add(self.addpage, 0, wx.TOP|wx.BOTTOM|wx.ADJUST_MINSIZE, 3)
        insertsizer.Add(self.insertpage, 0, wx.ADJUST_MINSIZE, 0)
        insertsizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        insertsizer.Add(self.pageinserted, 0, wx.LEFT|wx.TOP|wx.ADJUST_MINSIZE, 2)
        actionsizer.Add(insertsizer, 1, wx.TOP|wx.BOTTOM|wx.EXPAND, 3)
        deletesizer.Add(self.deletepage, 0, wx.ADJUST_MINSIZE, 0)
        deletesizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        deletesizer.Add(self.pagedeleted, 0, wx.LEFT|wx.TOP|wx.ADJUST_MINSIZE, 2)
        actionsizer.Add(deletesizer, 1, wx.TOP|wx.BOTTOM|wx.EXPAND, 3)
        actionsizer.Add(self.deleteall, 0, wx.TOP|wx.BOTTOM|wx.ADJUST_MINSIZE, 3)
        defaultsizer.Add(self.defaultpage, 0, wx.ADJUST_MINSIZE, 0)
        defaultsizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        defaultsizer.Add(self.pagedefault, 0, wx.LEFT|wx.TOP|wx.ADJUST_MINSIZE, 2)
        actionsizer.Add(defaultsizer, 1, wx.TOP|wx.BOTTOM|wx.EXPAND, 3)
        recreatesizer.Add(self.recreate, 0, wx.ADJUST_MINSIZE, 0)
        actionsizer.Add(recreatesizer, 1, wx.TOP|wx.BOTTOM|wx.EXPAND, 3)
        actionsizer.Add((0, 5), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(actionsizer, 0, wx.ALL|wx.EXPAND, 3)
        stylesizer.Add(self.nc_top, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        stylesizer.Add(self.nc_bottom, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        stylesizer.Add(self.nc_left, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        stylesizer.Add(self.nc_right, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        stylesizer.Add(self.fixedwidth, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        stylesizer.Add(self.rotate, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND|wx.ADJUST_MINSIZE, 3)        
        stylesizer.Add(self.expandable, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND|wx.ADJUST_MINSIZE, 3)        
        stylesizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(stylesizer, 0, wx.ALL|wx.EXPAND, 3)
        sizersizer.Add(self.sizerh, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        sizersizer.Add(self.sizerv, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        sizersizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(sizersizer, 0, wx.ALL|wx.EXPAND, 3)
        textsizer.Add(self.fontcolour, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        textsizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(textsizer, 0, wx.ALL|wx.EXPAND, 3)
        tabssizer.Add(self.tabimages, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.colourtabs, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.disabletab, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.drawx, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        xsizer.Add((0,3), 0)
        xsizer.Add(self.xemulestyle, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        xsizer.Add((0,3), 0)
        xsizer.Add(self.xoperastyle, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        xsizer.Add((0,3), 0)
        xsizer.Add(self.ximagestyle, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        tabssizer.Add(xsizer, 1, wx.BOTTOM|wx.EXPAND, 5)
        tabssizer.Add(self.highlight, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.focusindicator, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.convertimage, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.hideonsingle, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.enablepopup, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.tiling, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        xsizer3.Add((0,3), 0)
        xsizer3.Add(self.showcolumns, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        xsizer3.Add((0,3), 0)
        xsizer3.Add(self.showrows, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        tabssizer.Add(xsizer3, 1, wx.BOTTOM|wx.EXPAND, 5)
        tabssizer.Add(self.showtabs, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add(self.hidetabs, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tabssizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(tabssizer, 0, wx.ALL|wx.EXPAND, 3)
        stylesizer2.Add(self.wintabs, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        stylesizer2.Add(self.unixtabs, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        stylesizer2.Add(self.mactabs, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        xsizer5.Add((0,3), 0)
        xsizer5.Add(self.mac1, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        xsizer5.Add((0,3), 0)
        xsizer5.Add(self.mac2, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        xsizer5.Add((0,3), 0)
        xsizer5.Add(self.mac3, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        stylesizer2.Add(xsizer5, 1, wx.BOTTOM|wx.EXPAND, 5)
        stylesizer2.Add(self.gradtabs, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        xsizer7.Add((0,3), 0)
        xsizer7.Add(self.gradv, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        xsizer7.Add((0,3), 0)
        xsizer7.Add(self.gradh, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        stylesizer2.Add(xsizer7, 0, wx.BOTTOM, 5)
        sizerh1.Add(self.col1, 0, wx.LEFT, 5)
        sizerh1.Add(self.col2, 0, wx.LEFT, 3)
        xsizer6.Add(sizerh1, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        stylesizer2.Add(xsizer6, 0, wx.BOTTOM|wx.EXPAND, 5)
        stylesizer2.Add(self.singlegrad, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        
        leftpanelsizer.Add(stylesizer2, 0, wx.ALL|wx.EXPAND, 3)
        animationsizer.Add(self.animate, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        animationsizer.Add(self.draganddrop, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        animationsizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(animationsizer, 0, wx.ALL|wx.EXPAND, 3)
        tooltipsizer.Add(self.showtooltip, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        tooltipsizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(tooltipsizer, 0, wx.ALL|wx.EXPAND, 3)
        reparentsizer.Add(self.enablerep, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        xsizer2.Add((0,3), 0)
        xsizer2.Add(self.framerep, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        xsizer2.Add((0,3), 0)
        xsizer2.Add(self.nbrep, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        reparentsizer.Add(xsizer2, 1, wx.EXPAND)
        reparentsizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(reparentsizer, 0, wx.ALL|wx.EXPAND, 3)
        customsizer.Add(self.custom, 0, wx.ALL|wx.EXPAND|wx.ADJUST_MINSIZE, 3)
        xsizer4.Add((0,3), 0)
        xsizer4.Add(self.customimage, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        xsizer4.Add((0,3), 0)
        xsizer4.Add(self.customhtml, 0, wx.LEFT|wx.ADJUST_MINSIZE, 15)
        customsizer.Add(xsizer4, 1, wx.EXPAND)
        customsizer.Add((5, 0), 0, wx.ADJUST_MINSIZE, 0)
        leftpanelsizer.Add(customsizer, 0, wx.ALL|wx.EXPAND, 3)
        
        self.leftpanel.SetSizer(leftpanelsizer)
        leftpanelsizer.Layout()        

        self.Bind(wx.EVT_BUTTON, self.OnAddPage, self.addpage)
        self.Bind(wx.EVT_BUTTON, self.OnInsertPage, self.insertpage)
        self.Bind(wx.EVT_BUTTON, self.OnDeletePage, self.deletepage)
        self.Bind(wx.EVT_BUTTON, self.OnDeleteAllPages, self.deleteall)
        self.Bind(wx.EVT_BUTTON, self.OnDefaultPage, self.defaultpage)
        self.Bind(wx.EVT_BUTTON, self.RecreateNotebook, self.recreate)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnChangeNCStyle, self.nc_top)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnChangeNCStyle, self.nc_bottom)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnChangeNCStyle, self.nc_left)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnChangeNCStyle, self.nc_right)
        self.Bind(wx.EVT_CHECKBOX, self.OnChangeNCStyle, self.fixedwidth)
        self.Bind(wx.EVT_CHECKBOX, self.OnChangeNCStyle, self.rotate)
        self.Bind(wx.EVT_CHECKBOX, self.OnChangeNCStyle, self.expandable)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnChangeSizer, self.sizerh)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnChangeSizer, self.sizerv)
        self.Bind(wx.EVT_CHECKBOX, self.OnTextAttr, self.fontcolour)
        self.Bind(wx.EVT_CHECKBOX, self.OnShowImages, self.tabimages)
        self.Bind(wx.EVT_CHECKBOX, self.OnColourTabs, self.colourtabs)
        self.Bind(wx.EVT_CHECKBOX, self.OnDisableTab, self.disabletab)
        self.Bind(wx.EVT_CHECKBOX, self.OnDrawX, self.drawx)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnEmuleXStyle, self.xemulestyle)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnOperaXStyle, self.xoperastyle)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnImageXStyle, self.ximagestyle)
        self.Bind(wx.EVT_CHECKBOX, self.OnHighlight, self.highlight)
        self.Bind(wx.EVT_CHECKBOX, self.OnFocusIndicator, self.focusindicator)
        self.Bind(wx.EVT_CHECKBOX, self.OnConvertImage, self.convertimage)
        self.Bind(wx.EVT_CHECKBOX, self.OnHideOnSingle, self.hideonsingle)
        self.Bind(wx.EVT_CHECKBOX, self.OnPopupMenu, self.enablepopup)
        self.Bind(wx.EVT_CHECKBOX, self.OnEnableTiling, self.tiling)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnTile, self.showcolumns)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnTile, self.showrows)
        self.Bind(wx.EVT_CHECKBOX, self.OnShowTabs, self.showtabs)
        self.Bind(wx.EVT_CHECKBOX, self.OnHideTabs, self.hidetabs)
        self.Bind(wx.EVT_CHECKBOX, self.OnWinTabs, self.wintabs)
        self.Bind(wx.EVT_CHECKBOX, self.OnUnixTabs, self.unixtabs)
        self.Bind(wx.EVT_CHECKBOX, self.OnMacTabs, self.mactabs)
        self.Bind(wx.EVT_CHECKBOX, self.OnGradTabs, self.gradtabs)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnMacTheme, self.mac1)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnMacTheme, self.mac2)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnMacTheme, self.mac3)
        self.Bind(wx.EVT_BUTTON, self.OnFirstColour, self.col1)
        self.Bind(wx.EVT_BUTTON, self.OnSecondColour, self.col2)
        self.Bind(wx.EVT_CHECKBOX, self.OnSingleGrad, self.singlegrad)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnTabGradient, self.gradv)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnTabGradient, self.gradh)
        self.Bind(wx.EVT_CHECKBOX, self.OnAnimateTabs, self.animate)
        self.Bind(wx.EVT_CHECKBOX, self.OnDragAndDrop, self.draganddrop)
        self.Bind(wx.EVT_CHECKBOX, self.OnShowToolTip, self.showtooltip)
        self.Bind(wx.EVT_CHECKBOX, self.OnEnableReparenting, self.enablerep)
        self.Bind(wx.EVT_CHECKBOX, self.OnCustom, self.custom)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnCustomPanel, self.customimage)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnCustomPanel, self.customhtml)


    def RecreateNotebook(self, event=None):

        self.Freeze()
        
        if hasattr(self, "nb"):
            self.mainsizer.Detach(0)
            self.nb.Destroy()
            self.mainsizer.Layout()

        style = wx.NO_BORDER

        # Retrieve Notebook Styles
        if self.nc_top.GetValue() == 1:
            style = style | NC.NC_TOP
        elif self.nc_bottom.GetValue() == 1:
            style = style | NC.NC_BOTTOM
        elif self.nc_left.GetValue() == 1:
            style = style | NC.NC_LEFT
        elif self.nc_right.GetValue() == 1:
            style = style | NC.NC_RIGHT

        # Fixed Tab Width?
        if self.fixedwidth.GetValue() == 1:
            style = style | NC.NC_FIXED_WIDTH
            
        # Rotate?
        if self.rotate.GetValue() == 1:
            style = style | NC.NC_ROTATE
            
        # Expandable?
        if self.expandable.GetValue() == 1:
            style = style | NC.NC_EXPANDABLE

        # Which Orientation The Page Sizer Should Have? This Is Useful Only When You
        # Use The Option "Show In Column Mode"
        if self.sizerh.GetValue() == 1:
            nbsizer = wx.HORIZONTAL
        else:
            nbsizer = wx.VERTICAL
            
        self.nb = TestNotebookCtrl(self.panel, -1, style, nbsizer)
        self.nb.SetSelection(0)
    
        # Are We Showing Text Font & Colour Capabilities?
        if self.fontcolour.GetValue() == 1:        
            textcolour = self.textcolour
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPageTextColour(ii, textcolour[ii])
                self.nb.SetPageTextFont(ii, wx.Font(8, wx.SWISS, wx.NORMAL, wx.NORMAL, False, "Verdana"))
                self.nb.SetPageTextSecondaryFont(ii, wx.Font(8, wx.SWISS, wx.NORMAL, wx.BOLD, True, "Verdana"))
                
        # Are We Showing Images On Tabs?
        if self.tabimages.GetValue() == 1:
            for ii in xrange(self.nb.GetPageCount()):
                randimage = random.randint(0, len(ArtIDs) - 1)
                self.nb.SetPageImage(ii, randimage)

        # Do We Want Coloured Tabs?
        if self.colourtabs.GetValue() == 1:
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPageColour(ii, self.pagecolours[ii])

        # Here We Show How To Disable A Tab
        if self.disabletab.GetValue() == 1:
            self.nb.EnablePage(6, False)

        # We Want A Small Closing "X" At The Top Right Of Every Tabs
        if self.drawx.GetValue() == 1:
            self.convertimage.SetValue(0)
            self.xemulestyle.Enable(True)
            self.xoperastyle.Enable(True)
            self.ximagestyle.Enable(True)
            if self.xemulestyle.GetValue() == 1:
                self.nb.SetDrawX(True, 1)
            elif self.xoperastyle.GetValue == 2:
                self.nb.SetDrawX(True, 2)
            else:
                self.nb.SetDrawX(True, 3, wx.Bitmap("tab_on.png", wx.BITMAP_TYPE_PNG),
                                 wx.Bitmap("tab_close.png", wx.BITMAP_TYPE_PNG))
        else:
            self.xemulestyle.Enable(False)
            self.xoperastyle.Enable(False)
            self.ximagestyle.Enable(False)
            self.nb.SetDrawX(False)

        # We Want To Highlight A Selected Tab
        if self.highlight.GetValue() == 1:
            self.nb.SetHighlightSelection(True)

        # Use Tabs Focus Indicator?
        if self.focusindicator.GetValue() == 1:
            self.nb.SetUseFocusIndicator(True)

        # Convert Tab Image To Opera Style Close Button?
        if self.convertimage.GetValue() == 1:
            self.nb.SetImageToCloseButton(True)
            self.drawx.SetValue(0)
            self.xemulestyle.Enable(False)
            self.xoperastyle.Enable(False)
            self.ximagestyle.Enable(False)
            self.nb.SetDrawX(False)

        # Hide TabCtrl When Only One Tab Present
        if self.hideonsingle.GetValue() == 1:
            self.nb.HideOnSingleTab(True)

        # Do We Want Popup Menus?
        if self.enablepopup.GetValue() == 1:
            self.CreatePopupMenus()

        # Show In Column/Row Mode (Tile)?
        if self.tiling.GetValue() == 1:
            self.showcolumns.Enable(True)
            self.showrows.Enable(True)
            self.OnTile(None)
        else:
            self.showcolumns.Enable(False)
            self.showrows.Enable(False)
            
        # Show Tabs Or Hide Them?
        if self.showtabs.GetValue() == 0:
            self.nb.ShowTabs(True)
        else:
            self.nb.ShowTabs(False)
            
        # Show Animation On Second Tab
        if self.animate.GetValue() == 1:
            self.nb.SetAnimationImages(1, [7, 8, 9, 10, 11, 36])
            self.nb.StartAnimation(1, 1000)

        # We Want To Enable Drag And Drop
        if self.draganddrop.GetValue() == 1:
            self.nb.EnableDragAndDrop(True)

        # Do We Want To Show ToolTips?
        for ii in xrange(self.nb.GetPageCount()):
            self.nb.SetPageToolTip(ii, self.tooltips[ii], 1000)
                
        if self.showtooltip.GetValue() == 1:
            self.nb.EnableToolTip(True)

        # Draw Mac Themes On Tabs?
        if self.mactabs.GetValue() == 1:
            if self.mac1.GetValue() == 1:
                self.tabstyle.EnableAquaTheme(True, 2)
            elif self.mac2.GetValue() == 1:
                self.tabstyle.EnableAquaTheme(True, 1)
            else:
                self.tabstyle.EnableMetalTheme(True)

            self.nb.ApplyTabTheme(self.tabstyle)
            
        # Draw KDE Theme On Tabs?
        if self.unixtabs.GetValue() == 1:
            self.tabstyle.EnableKDETheme(True)
            self.nb.ApplyTabTheme(self.tabstyle)

        # Draw Windows Silver Theme On Tabs?
        if self.wintabs.GetValue() == 1:
            self.tabstyle.EnableSilverTheme(True)
            self.nb.ApplyTabTheme(self.tabstyle)

        # Draw Same Gradients On All Tabs            
        if self.gradtabs.GetValue() == 1:
            col1 = self.col1.GetBackgroundColour()
            col2 = self.col2.GetBackgroundColour()
            self.tabstyle.SetFirstGradientColour(col1)
            self.tabstyle.SetSecondGradientColour(col2)
            if self.gradv.GetValue() == 1:
                self.tabstyle.EnableGradientStyle(True, 1)
            else:
                self.tabstyle.EnableGradientStyle(True, 2)

            self.nb.ApplyTabTheme(self.tabstyle)              

        # Do We Want A Different Gradient On Each Tab?
        if self.singlegrad.GetValue() == 1:
            self.tabstyle.ResetDefaults()
            self.nb.ApplyTabTheme(self.tabstyle)
            for ii in xrange(self.nb.GetPageCount()):
                color = self.pagecolours[ii]
                self.nb.SetPageFirstGradientColour(ii, color)
                r, g, b = int(color.Red()), int(color.Green()), int(color.Blue())
                color = ((r >> 1) + 20, (g >> 1) + 20, (b >> 1) + 20)
                colour = wx.Colour(color[0], color[1], color[2])
                self.nb.SetPageSecondGradientColour(ii, colour)
                
            self.nb.EnableTabGradients(True)
            
        self.mainsizer.Add(self.nb, 1, wx.EXPAND)
        self.mainsizer.Layout()

        self.Thaw()

        self.nb.Bind(NC.EVT_NOTEBOOKCTRL_PAGE_CHANGED, self.OnPageChanged)
        self.nb.Bind(NC.EVT_NOTEBOOKCTRL_PAGE_CHANGING, self.OnPageChanging)
        self.nb.Bind(NC.EVT_NOTEBOOKCTRL_PAGE_CLOSING, self.OnPageClosing)
        self.nb.Bind(NC.EVT_NOTEBOOKCTRL_PAGE_DND, self.OnDnD)
        self.nb.Bind(NC.EVT_NOTEBOOKCTRL_PAGE_DCLICK, self.OnLeftDClick)
        self.nb.Bind(NC.EVT_NOTEBOOKCTRL_PAGE_RIGHT, self.OnRight)
        self.nb.Bind(NC.EVT_NOTEBOOKCTRL_PAGE_MIDDLE, self.OnMiddle)


    def OnChangeNCStyle(self, event):

        self.RecreateNotebook()
        self.log.write("OnChangeNCStyle: NotebookCtrl Recreated From Scratch\n")  

        event.Skip()


    def OnChangeSizer(self, event):
        
        self.RecreateNotebook()
        self.log.write("OnChangeSizer: NotebookCtrl Recreated From Scratch\n")  

        event.Skip()

        
    def OnTextAttr(self, event):

        if self.fontcolour.GetValue() == 1:        
            textcolour = self.textcolour
            count = 0
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPageTextColour(ii, textcolour[count])
                self.nb.SetPageTextFont(ii, wx.Font(8, wx.SWISS, wx.NORMAL, wx.NORMAL, False, "Verdana"))
                self.nb.SetPageTextSecondaryFont(ii, wx.Font(8, wx.SWISS, wx.NORMAL, wx.BOLD, True, "Verdana"))
                count = count + 1
                if count == len(textcolour):
                    count = 0

            self.log.write("OnTextAttr: Text Font And Colour Applied \n")
        else:
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPageTextColour(ii, wx.BLACK)
                self.nb.SetPageTextSecondaryFont(ii, self.standardfont)
                self.nb.SetPageTextFont(ii, self.standardfont)
                    
            self.log.write("OnTextAttr: Default GUI Text Font And Colour Restored\n")  

        event.Skip()
        

    def OnShowImages(self, event):

        # Are We Showing Images On Tabs?
        if self.tabimages.GetValue() == 1:
            for ii in xrange(self.nb.GetPageCount()):
                randimage = random.randint(0, len(ArtIDs) - 1)
                self.nb.SetPageImage(ii, randimage)

            self.log.write("OnShowImages: Some Images Shown On NotebookCtrl Tabs\n")
        else:
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPageImage(ii, -1)

            self.log.write("OnShowImages: No Images Shown On NotebookCtrl Tabs\n")                  

        event.Skip()


    def OnColourTabs(self, event):

        # Do We Want Coloured Tabs?
        if self.colourtabs.GetValue() == 1:
            count = 0
            self.tabstyle.ResetDefaults()
            self.nb.ApplyTabTheme(self.tabstyle)
            self.nb.EnableTabGradients(False)
            self.mactabs.SetValue(0)
            self.gradtabs.SetValue(0)
            self.unixtabs.SetValue(0)
            self.wintabs.SetValue(0)
            self.singlegrad.SetValue(0)
            self.col1.Enable(False)
            self.col2.Enable(False)
            self.gradv.Enable(False)
            self.gradh.Enable(False)
            self.mac1.Enable(False)
            self.mac2.Enable(False)
            self.mac3.Enable(False)
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPageColour(ii, self.pagecolours[count])
                count = count + 1
                if count == len(self.textcolour):
                    count = 0
                    
            self.log.write("OnColourTabs: NotebookCtrl Tabs Coloured\n")
        else:
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPageColour(ii)

            self.log.write("OnColourTabs: NotebookCtrl Tabs Native GUI Colour\n")
                
        event.Skip()
        

    def OnDisableTab(self, event): 

        # Here We Show How To Disable A Tab
        if self.disabletab.GetValue() == 1:
            if self.nb.GetPageCount() > 0:
                if self.nb.GetPageCount() >= 7:
                    self.nb.EnablePage(6, False)
                    self.log.write("OnDisableTab: Disabled Page 6\n")
                else:
                    self.nb.EnablePage(self.nb.GetPageCount()-1, False)
                    self.log.write("OnDisableTab: Disabled Page " + \
                                   str(self.nb.GetPageCount()) + "\n")
            else:
                self.log.write("OnDisableTab: Impossible To Disbale Tabs. "\
                               "No Pages In NotebookCtrl\n")
        else:
            for ii in xrange(self.nb.GetPageCount()):
                if not self.nb.IsPageEnabled(ii):
                    self.nb.EnablePage(ii, True)
                    
            self.log.write("OnDisableTab: All Pages Enabled\n")
                           
            
    def OnDrawX(self, event):

        # We Want A Small Closing "X" At The Top Right Of Every Tabs
        if self.drawx.GetValue() == 1:
            self.xemulestyle.Enable(True)
            self.xoperastyle.Enable(True)
            self.ximagestyle.Enable(True)
            self.convertimage.SetValue(0)
            if self.xemulestyle.GetValue() == 1:
                self.nb.SetDrawX(True, 1)
                self.log.write("OnDrawX: Draw eMule-Style X With Event Binder Enabled\n")
            elif self.xoperastyle.GetValue() == 1:
                self.nb.SetDrawX(True, 2)
                self.log.write("OnDrawX: Draw Opera-Style X With Event Binder Enabled\n")
            else:
                self.nb.SetDrawX(True, 3, wx.Bitmap("tab_on.png", wx.BITMAP_TYPE_PNG),
                                 wx.Bitmap("tab_close.png" ,wx.BITMAP_TYPE_PNG ))
                self.log.write("OnDrawX: Draw Custom Style X With Event Binder Enabled\n")
        else:
            self.xemulestyle.Enable(False)
            self.xoperastyle.Enable(False)
            self.nb.SetDrawX(False)
            self.log.write("OnDrawX: Draw Small X With Event Binder Disabled\n")
            
        event.Skip()


    def OnEmuleXStyle(self, event):
        
        self.nb.SetDrawX(True, 1)
        event.Skip()


    def OnOperaXStyle(self, event):
        
        self.nb.SetDrawX(True, 2)
        event.Skip()        


    def OnImageXStyle(self, event):

        self.nb.SetDrawX(True, 3, wx.Bitmap("tab_on.png", wx.BITMAP_TYPE_PNG),
                         wx.Bitmap("tab_close.png" ,wx.BITMAP_TYPE_PNG ))
        event.Skip()
        

    def OnHighlight(self, event):

        # We Want To Highlight A Selected Tab
        if self.highlight.GetValue() == 1:
            self.nb.SetHighlightSelection(True)
            self.log.write("OnHighlight: Highlight On Selection Enabled\n")
        else:
            self.nb.SetHighlightSelection(False)
            self.log.write("OnHighlight: Highlight On Selection Disabled\n")
            
        event.Skip()
        

    def OnFocusIndicator(self, event):

        # Use Tabs Focus Indicator?
        if self.focusindicator.GetValue() == 1:
            self.nb.SetUseFocusIndicator(True)
            self.log.write("OnFocusIndicator: Focus Indicator Enabled\n")
        else:
            self.nb.SetUseFocusIndicator(False)
            self.log.write("OnFocusIndicator: Focus Indicator Disabled\n")
            
        event.Skip()


    def OnConvertImage(self, event):

        if self.convertimage.GetValue() == 1:
            self.nb.SetImageToCloseButton(True)
            self.log.write("OnConvertImage: Tab Images Converted To Close Button On Mouse Hovering\n")
            self.drawx.SetValue(0)
            self.xemulestyle.Enable(False)
            self.xoperastyle.Enable(False)
            self.ximagestyle.Enable(False)
            self.nb.SetDrawX(False)
        else:
            self.nb.SetImageToCloseButton(False)
            self.log.write("OnConvertImage: Tab Images Not Converted To Close Button On Mouse Hovering\n")
            
        event.Skip()


    def OnHideOnSingle(self, event):

        if self.hideonsingle.GetValue() == 1:
            self.nb.HideOnSingleTab(True)
            self.log.write("OnHideOnSingle: Hiding TabCtrl When Only One Tab Present\n")
        else:
            self.nb.HideOnSingleTab(False)
            self.log.write("OnHideOnSingle: Showing TabCtrl Always\n")

        event.Skip()            
            

    def OnPopupMenu(self, event):

        if self.enablepopup.GetValue() == 1:
            self.CreatePopupMenus()
            self.log.write("OnPopupMenu: Popup Menu On Tabs Enabled (Only Tabs 1, 3, 5)\n")
        else:
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPagePopupMenu(ii, None)

            self.log.write("OnPopupMenu: Popup Menu On Tabs Disabled\n")

        event.Skip()
        

    def OnAnimateTabs(self, event):

        # Animate A Tab (If Present)
        if self.animate.GetValue() == 1:
            if self.nb.GetPageCount() > 0:

                imgarray = []
                for ii in xrange(6):
                    imgarray.append(random.randint(0, 36))
                
                if self.nb.GetPageCount() > 1:
                    self.nb.SetPageImage(1, imgarray[0])
                    self.nb.SetAnimationImages(1, imgarray)
                    self.nb.StartAnimation(1, 1000)
                    self.log.write("OnAnimateTabs: Animation Started On Page 2, "\
                                   "Timer 1000 ms\n")
                else:
                    self.nb.SetPageImage(0, imgarray[0])
                    self.nb.SetAnimationImages(0, imgarray)
                    self.nb.StartAnimation(0, 1000)
                    self.log.write("OnAnimateTabs: Animation Started On Page 1, "\
                                   "Timer 1000 ms\n")
            else:
                strs = "OnAnimateTabs: Impossible To Start Animation. No Pages "\
                       "In NotebookCtrl\n"
                self.log.write(strs)
        else:
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.StopAnimation(ii)
                
            self.log.write("OnAnimateTabs: Animation Stopped\n")
            
        event.Skip()


    def OnEnableTiling(self, event):

        if self.tiling.GetValue() == 1:
            self.log.write("OnEnableTiling: Tiling Pages Enabled\n")
            self.showcolumns.Enable(True)
            self.showrows.Enable(True)
            self.OnTile(None)
        else:
            self.log.write("OnEnableTiling: Tiling Pages Disabled\n")
            self.showcolumns.Enable(False)
            self.showrows.Enable(False)
            self.nb.Tile(False)
            
            
    def OnTile(self, event):

        if self.showcolumns.GetValue() == 1:
            self.log.write("OnTile: Tiling Pages Vertically\n")
            self.nb.Tile(True, wx.HORIZONTAL)
        elif self.showrows.GetValue() == 1:
            self.log.write("OnTile: Tiling Pages Horizontally\n")
            self.nb.Tile(True, wx.VERTICAL)

        if event is not None:
            event.Skip()            


    def OnShowTabs(self, event):

        # Show Tabs Or Hide Them?
        if self.showtabs.GetValue() == 1:
            self.log.write("OnShowTabs: Hiding Tabs In NotebookCtrl\n")
            self.nb.ShowTabs(False)
        else:
            self.log.write("OnShowTabs: Showing Tabs In NotebookCtrl\n")
            self.nb.ShowTabs(True)

        event.Skip()


    def OnHideTabs(self, event):

        if self.hidetabs.GetValue() == 1:
            self.log.write("OnHideTabs: Hiding User Selected Tabs Via Menu\n")
            self.nb.EnableHiding(True)
        else:
            self.log.write("OnHideTabs: Hiding User Selected Tabs Disabled\n")
            self.nb.EnableHiding(False)
            

    def OnMacTabs(self, event):

        if self.mactabs.GetValue() == 1:
            
            self.log.write("OnMacTabs: Mac Tabs Themes Enabled\n")  
            self.gradtabs.SetValue(0)
            self.unixtabs.SetValue(0)
            self.wintabs.SetValue(0)
            self.singlegrad.SetValue(0)
            self.col1.Enable(False)
            self.col2.Enable(False)
            self.gradv.Enable(False)
            self.gradh.Enable(False)
            self.mac1.Enable(True)
            self.mac2.Enable(True)
            self.mac3.Enable(True)
            self.OnMacTheme(None)
            
        else:
            
            self.log.write("OnMacTabs: Mac Tabs Themes Disabled\n")  
            self.mac1.Enable(False)
            self.mac2.Enable(False)
            self.mac3.Enable(False)
            self.tabstyle.ResetDefaults()
            self.nb.ApplyTabTheme(self.tabstyle)

        self.nb.Refresh()

        if event is not None:
            event.Skip()
        

    def OnGradTabs(self, event):

        if self.gradtabs.GetValue() == 1:
            self.log.write("OnGradTabs: Gradient Coloured Tabs Enabled\n")  
            self.mactabs.SetValue(0)
            self.unixtabs.SetValue(0)
            self.wintabs.SetValue(0)
            self.singlegrad.SetValue(0)
            self.mac1.Enable(False)
            self.mac2.Enable(False)
            self.mac3.Enable(False)
            self.col1.Enable(True)
            self.col2.Enable(True)
            self.gradv.Enable(True)
            self.gradh.Enable(True)
            self.OnTabGradient(None)
            
        else:
            
            self.log.write("OnGradTabs: Gradient Coloured Tabs Disabled\n")              
            self.col1.Enable(False)
            self.col2.Enable(False)
            self.gradv.Enable(False)
            self.gradh.Enable(False)
            self.tabstyle.ResetDefaults()
            self.nb.ApplyTabTheme(self.tabstyle)

        self.nb.Refresh()
        
        if event is not None:
            event.Skip()


    def OnUnixTabs(self, event):

        if self.unixtabs.GetValue() == 1:
            self.log.write("OnUnixTabs: KDE Unix Theme On Tabs Enabled\n")  
            self.mactabs.SetValue(0)
            self.gradtabs.SetValue(0)
            self.wintabs.SetValue(0)
            self.singlegrad.SetValue(0)
            self.mac1.Enable(False)
            self.mac2.Enable(False)
            self.mac3.Enable(False)
            self.col1.Enable(False)
            self.col2.Enable(False)
            self.gradv.Enable(False)
            self.gradh.Enable(False)
            self.nb.EnableTabGradients(False)
            self.tabstyle.EnableKDETheme(True)
            self.nb.ApplyTabTheme(self.tabstyle)
            
        else:
            
            self.log.write("OnUnixTabs: KDE Unix Theme On Tabs Disabled\n")
            self.tabstyle.ResetDefaults()
            self.nb.ApplyTabTheme(self.tabstyle)

        self.nb.Refresh()
        
        if event is not None:
            event.Skip()
            

    def OnWinTabs(self, event):

        if self.wintabs.GetValue() == 1:
            self.log.write("OnWinTabs: Windows Theme On Tabs Enabled\n")  
            self.mactabs.SetValue(0)
            self.gradtabs.SetValue(0)
            self.unixtabs.SetValue(0)
            self.singlegrad.SetValue(0)
            self.mac1.Enable(False)
            self.mac2.Enable(False)
            self.mac3.Enable(False)
            self.col1.Enable(False)
            self.col2.Enable(False)
            self.gradv.Enable(False)
            self.gradh.Enable(False)
            self.nb.EnableTabGradients(False)
            self.tabstyle.EnableSilverTheme(True)
            self.nb.ApplyTabTheme(self.tabstyle)
            
        else:
            
            self.log.write("OnWinTabs: Windows Theme On Tabs Disabled\n")
            self.tabstyle.ResetDefaults()
            self.nb.ApplyTabTheme(self.tabstyle)

        self.nb.Refresh()
        
        if event is not None:
            event.Skip()
            

    def OnTabGradient(self, event):

        col1 = self.col1.GetBackgroundColour()
        col2 = self.col2.GetBackgroundColour()
        
        self.tabstyle.SetFirstGradientColour(col1)
        self.tabstyle.SetSecondGradientColour(col2)
            
        if self.gradv.GetValue() == 1:
            self.tabstyle.EnableGradientStyle(True, 1)
            self.log.write("OnTabGradient: Vertical Gradient Colour On Tabs\n") 
        else:
            self.tabstyle.EnableGradientStyle(True, 2)
            self.log.write("OnTabGradient: Horizontal Gradient Colour On Tabs\n") 

        self.nb.EnableTabGradients(False)
        self.nb.ApplyTabTheme(self.tabstyle)
        self.nb.Refresh()
        
        if event is not None:
            event.Skip()


    def OnMacTheme(self, event):

        if self.mac1.GetValue() == 1:
            self.log.write("OnMacTheme: Mac Theme Chosen: Aqua Light\n")  
            self.tabstyle.EnableAquaTheme(True, 2)
        elif self.mac2.GetValue() == 1:
            self.log.write("OnMacTheme: Mac Theme Chosen: Aqua Dark\n")  
            self.tabstyle.EnableAquaTheme(True, 1)
        else:
            self.log.write("OnMacTheme: Mac Theme Chosen: Metal\n")
            self.tabstyle.EnableMetalTheme(True)

        self.nb.EnableTabGradients(False)            
        self.nb.ApplyTabTheme(self.tabstyle)
        
        if event is not None:
            event.Skip()
            

    def OnFirstColour(self, event):

        dlg = wx.ColourDialog(self)

        # Ensure the full colour dialog is displayed, 
        # not the abbreviated version.
        old = self.col1.GetBackgroundColour()
        
        dlg.GetColourData().SetChooseFull(True)

        if dlg.ShowModal() == wx.ID_OK:

            # If the user selected OK, then the dialog's wx.ColourData will
            # contain valid information. Fetch the data ...
            data = dlg.GetColourData()

            # ... then do something with it. The actual colour data will be
            # returned as a three-tuple (r, g, b) in this particular case.
            col1 = data.GetColour().Get()
            self.col1.SetBackgroundColour(col1)
            self.tabstyle.SetFirstGradientColour(wx.Colour(col1[0], col1[1], col1[2]))
            self.nb.ApplyTabTheme(self.tabstyle)
            
            self.log.write("OnFirstColour: First Colour Changed From " + str(old) + " To " + str(col1) + "\n")
            self.nb.Refresh()
            
        # Once the dialog is destroyed, Mr. wx.ColourData is no longer your
        # friend. Don't use it again!
        dlg.Destroy()


    def OnSecondColour(self, event):

        dlg = wx.ColourDialog(self)

        # Ensure the full colour dialog is displayed, 
        # not the abbreviated version.
        old = self.col2.GetBackgroundColour()
         
        dlg.GetColourData().SetChooseFull(True)
        
        if dlg.ShowModal() == wx.ID_OK:

            # If the user selected OK, then the dialog's wx.ColourData will
            # contain valid information. Fetch the data ...
            data = dlg.GetColourData()

            # ... then do something with it. The actual colour data will be
            # returned as a three-tuple (r, g, b) in this particular case.
            col2 = data.GetColour().Get()
            self.col2.SetBackgroundColour(col2)
            self.tabstyle.SetFirstGradientColour(wx.Colour(col2[0], col2[1], col2[2]))
            self.nb.ApplyTabTheme(self.tabstyle)
            self.log.write("OnSecondColour: Second Colour Changed From " + str(old) + " To " + str(col2) + "\n")
            self.nb.Refresh()
            
        # Once the dialog is destroyed, Mr. wx.ColourData is no longer your
        # friend. Don't use it again!
        dlg.Destroy()


    def OnSingleGrad(self, event):

        if self.singlegrad.GetValue() == 1:
            self.mactabs.SetValue(0)
            self.gradtabs.SetValue(0)
            self.unixtabs.SetValue(0)
            self.wintabs.SetValue(0)
            self.mac1.Enable(False)
            self.mac2.Enable(False)
            self.mac3.Enable(False)
            self.col1.Enable(False)
            self.col2.Enable(False)
            self.gradv.Enable(False)
            self.gradh.Enable(False)
            self.tabstyle.ResetDefaults()
            self.nb.ApplyTabTheme(self.tabstyle)
            
            for ii in xrange(self.nb.GetPageCount()):
                color = self.pagecolours[ii]
                self.nb.SetPageFirstGradientColour(ii, color)
                r, g, b = int(color.Red()), int(color.Green()), int(color.Blue())
                color = ((r >> 1) + 20, (g >> 1) + 20, (b >> 1) + 20)
                colour = wx.Colour(color[0], color[1], color[2])
                self.nb.SetPageSecondGradientColour(ii, colour)

            self.nb.EnableTabGradients(True)
            self.log.write("OnSingleGrad: Each Tab Has Its Own Gradient\n")
        else:
            self.nb.EnableTabGradients(False)
            self.log.write("OnSingleGrad: Single Gradients Disabled\n")

        event.Skip()            
                

    def OnDragAndDrop(self, event):

        # We Want To Enable Drag And Drop
        if self.draganddrop.GetValue() == 1:
            self.nb.EnableDragAndDrop(True)
            self.log.write("OnDragAndDrop: Drag And Drop Enabled\n")
        else:
            self.nb.EnableDragAndDrop(False)
            self.log.write("OnDragAndDrop: Drag And Drop Disabled\n")
            
        event.Skip()
        

    def OnShowToolTip(self, event):

        # Do We Want To Show ToolTips?
        if self.showtooltip.GetValue() == 1:
            self.nb.EnableToolTip(True)
            count = 0
            for ii in xrange(self.nb.GetPageCount()):
                self.nb.SetPageToolTip(ii, self.tooltips[count], 1000)
                count = count + 1
                if count == len(self.tooltips):
                    count = 0
                    
            self.log.write("OnShowToolTip: ToolTips Enabled (Not All Tabs Have ToolTips!)\n")
        else:
            self.nb.EnableToolTip(False)
            self.log.write("OnShowToolTip: ToolTips Disabled\n")
            
        event.Skip()
        

    def OnEnableReparenting(self, event):

        # Do We Want To Enable Reparenting? If Yes, Try To Double-Click On Tabs!!
        if self.enablerep.GetValue() == 1:
            self.framerep.Enable(True)
            self.nbrep.Enable(True)
            self.log.write("OnEnableReparenting: Reparenting Enabled In The Demo\n")
        else:
            self.framerep.Enable(False)
            self.nbrep.Enable(False)
            self.log.write("OnEnableReparenting: Reparenting Disabled In The Demo\n")

        event.Skip()


    def OnCustom(self, event):

        if self.custom.GetValue() == 1:
            self.customimage.Enable(True)
            self.customhtml.Enable(True)
            self.log.write("OnCustom: Custom Page Added\n")
            self.OnCustomPanel(None)
        else:
            self.nb.SetCustomPage(None)
            self.customimage.Enable(False)
            self.customhtml.Enable(False)
            self.log.write("OnCustom: Custom Page Removed\n")
        
        event.Skip()
        

    def OnCustomPanel(self, event):

        if self.customimage.GetValue() == 1:
            self.log.write("OnCustomPanel: Custom Panel With Logo!\n")
            custom = LogoPanel(self.nb, -1)
            self.nb.SetCustomPage(custom)
        else:
            self.log.write("OnCustomPanel: Custom Panel With HTML Info!\n")
            custom = HTMLPanel(self.nb, -1)
            self.nb.SetCustomPage(custom)

        if event is not None:
            event.Skip()


    def CheckOptions(self, nPage, pos):

        if self.fontcolour.GetValue() == 1:        
            textcolour = self.textcolour[nPage]            
            self.nb.SetPageTextColour(pos, textcolour)
            self.nb.SetPageTextFont(pos, wx.Font(8, wx.SWISS, wx.NORMAL, wx.NORMAL, False, "Verdana"))
            self.nb.SetPageTextSecondaryFont(pos, wx.Font(8, wx.SWISS, wx.NORMAL, wx.BOLD, True, "Verdana"))
                
        # Are We Showing Images On Tabs?
        if self.tabimages.GetValue() == 1:
            randimage = random.randint(0, len(ArtIDs) - 1)
            self.nb.SetPageImage(pos, randimage)

        # Do We Want Coloured Tabs?
        if self.colourtabs.GetValue() == 1:
            self.nb.SetPageColour(pos, self.pagecolours[nPage])
            
        # Do We Want To Show ToolTips?
        self.nb.SetPageToolTip(pos, self.tooltips[nPage], 1000)

        # Show A Different Gradient On Every Tab
        if self.singlegrad.GetValue() == 1:
            color = self.pagecolours[nPage]
            self.nb.SetPageFirstGradientColour(pos, color)
            r, g, b = int(color.Red()), int(color.Green()), int(color.Blue())
            color = ((r >> 1) + 20, (g >> 1) + 20, (b >> 1) + 20)
            colour = wx.Colour(color[0], color[1], color[2])
            self.nb.SetPageSecondGradientColour(pos, colour)

        
    def OnAddPage(self, event):

        newpage = self.nb.GetPageCount()%9

        if newpage == 0:
            win = self.nb.makeColorPanel(wx.BLUE)
            self.nb.AddPage(win, "Blue")
            st = wx.StaticText(win.win, -1,
                              "You Can Put Nearly Any Type Of Window Here,\n"
                              "And Tabs Can Be At The Top Or At The Bottom\n"
                              "Of The NotebookCtrl.",
                              (10, 10))

            st.SetForegroundColour(wx.WHITE)
            st.SetBackgroundColour(wx.BLUE)

        elif newpage == 1:

            win = self.nb.makeColorPanel(wx.RED)
            self.nb.AddPage(win, "Red")

        elif newpage == 2:                

            win = ScrolledWindow.MyCanvas(self.nb)
            self.nb.AddPage(win, 'ScrolledWindow')

        elif newpage == 3:

            win = self.nb.makeColorPanel(wx.GREEN)
            self.nb.AddPage(win, "Green")

        elif newpage == 4:

            win = GridSimple.SimpleGrid(self.nb, None)
            self.nb.AddPage(win, "Grid")

        elif newpage == 5:
            
            win = ListCtrl.TestListCtrlPanel(self.nb, None)
            self.nb.AddPage(win, 'List')

        elif newpage == 6:
            
            win = self.nb.makeColorPanel(wx.CYAN)
            self.nb.AddPage(win, "Cyan")

        elif newpage == 7:
            
            win = self.nb.makeColorPanel(wx.NamedColour('MIDNIGHT BLUE'))
            self.nb.AddPage(win, "MIDNIGHT BLUE")

        else:
            
            win = self.nb.makeColorPanel(wx.NamedColour('INDIAN RED'))
            self.nb.AddPage(win, "INDIAN RED")

        self.CheckOptions(newpage, self.nb.GetPageCount()-1)
            
        self.log.write("OnAddPage: Added Page Type " + str(newpage) + "\n")
        
        event.Skip()


    def OnInsertPage(self, event):

        val = self.pageinserted.GetValue()
        
        if not val.isdigit():
            errstr = "Error: Non Integer Value For The Text Control! "
            dlg = wx.MessageDialog(self, errstr, "NotebookCtrlDemo Error",
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        if int(val) != val:
            val = int(val)
            self.pageinserted.SetValue(str(val))

        if val >= self.nb.GetPageCount() + 1:
            errstr = "Error: Invalid Page Index For Insert! "
            dlg = wx.MessageDialog(self, errstr, "NotebookCtrlDemo Error",
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        newpage = random.randint(0, 8)

        if newpage == 0:
            win = self.nb.makeColorPanel(wx.BLUE)
            self.nb.InsertPage(val, win, "Blue", True)
            st = wx.StaticText(win.win, -1,
                              "You can put nearly any type of window here,\n"
                              "and if the platform supports it then the\n"
                              "tabs can be on any side of the notebook.",
                              (10, 10))

            st.SetForegroundColour(wx.WHITE)
            st.SetBackgroundColour(wx.BLUE)

        elif newpage == 1:

            win = self.nb.makeColorPanel(wx.RED)
            self.nb.InsertPage(val, win, "Red", True)

        elif newpage == 2:                

            win = ScrolledWindow.MyCanvas(self.nb)
            self.nb.InsertPage(val, win, 'ScrolledWindow', True)

        elif newpage == 3:

            win = self.nb.makeColorPanel(wx.GREEN)
            self.nb.InsertPage(val, win, "Green", True)

        elif newpage == 4:

            win = GridSimple.SimpleGrid(self.nb, None)
            self.nb.InsertPage(val, win, "Grid", True)

        elif newpage == 5:
            
            win = ListCtrl.TestListCtrlPanel(self.nb, None)
            self.nb.InsertPage(val, win, 'List', True)

        elif newpage == 6:
            
            win = self.nb.makeColorPanel(wx.CYAN)
            self.nb.InsertPage(val, win, "Cyan", True)

        elif newpage == 7:
            
            win = self.nb.makeColorPanel(wx.NamedColour('MIDNIGHT BLUE'))
            self.nb.InsertPage(val, win, "MIDNIGHT BLUE", True)

        else:
            
            win = self.nb.makeColorPanel(wx.NamedColour('INDIAN RED'))
            self.nb.InsertPage(val, win, "INDIAN RED", True)

        self.CheckOptions(newpage, val)
        
        self.log.write("OnInsertPage: Inserted Page At Position " + str(val) + "\n")
        
        event.Skip()


    def OnDeletePage(self, event):

        val = self.pagedeleted.GetValue()
        
        if not val.isdigit():
            errstr = "Error: Non Integer Value For The Text Control! "
            dlg = wx.MessageDialog(self, errstr, "NotebookCtrlDemo Error",
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        if int(val) != val:
            val = int(val)
            self.pagedeleted.SetValue(str(val))

        if val >= self.nb.GetPageCount():
            errstr = "Error: Invalid Page Index For Delete! "
            dlg = wx.MessageDialog(self, errstr, "NotebookCtrlDemo Error",
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        self.nb.DeletePage(val)
        self.log.write("OnDeletePage: Deleted Page " + str(val) + \
                       " By Calling DeletePage()\n")
        
        event.Skip()


    def OnDeleteAllPages(self, event):

        self.log.write("OnDeleteAllPages: All Pages Deleted\n")
        self.nb.DeleteAllPages()        


    def OnDefaultPage(self, event):

        val = self.pagedefault.GetValue()
        try:
            val = int(val)
        except:
            errstr = "Error: Non Integer Value For The Text Control! "
            dlg = wx.MessageDialog(self, errstr, "NotebookCtrlDemo Error",
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        if int(val) != val:
            val = int(val)
            self.pagedefault.SetValue(str(val))

        if val >= self.nb.GetPageCount():
            errstr = "Error: Invalid Page Index For Delete! "
            dlg = wx.MessageDialog(self, errstr, "NotebookCtrlDemo Error",
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        self.nb.SetDefaultPage(val)
        self.log.write("OnDefaultPage: Set Default Page " + str(val) + "\n")
        
        event.Skip()


    def OnPageChanged(self, event):
        
        old = event.GetOldSelection()
        new = event.GetSelection()
        sel = self.nb.GetSelection()
        self.log.write('OnPageChanged: Old:%d, New:%d, Sel:%d\n' % (old, new, sel))
        
        event.Skip()
        

    def OnPageChanging(self, event):
        
        old = event.GetOldSelection()
        new = event.GetSelection()
        sel = self.nb.GetSelection()

        if self.fontcolour.GetValue() == 1:        
            self.nb.SetPageTextFont(new, wx.Font(8, wx.SWISS, wx.NORMAL,
                                              wx.BOLD, True, "Verdana"))
            self.nb.SetPageTextFont(old, wx.Font(8, wx.SWISS, wx.NORMAL,
                                              wx.NORMAL, False, "Verdana"))
        
        self.log.write('OnPageChanging: Old:%d, New:%d, Sel:%d\n' % (old, new, sel))

        event.Skip()


    def OnPageClosing(self, event):

        msg = "Are You Sure You Want To Close This Page?"
        dlg = wx.MessageDialog(self, msg, "NotebookCtrl Question",
                               wx.YES_NO | wx.NO_DEFAULT | wx.CANCEL | wx.ICON_QUESTION)

        if wx.Platform != '__WXMAC__':
            dlg.SetFont(wx.Font(8, wx.NORMAL, wx.NORMAL, wx.NORMAL, False))
        
        if dlg.ShowModal() in [wx.ID_NO, wx.ID_CANCEL]:
            self.log.write("OnPageClosing: Closing Event Blocked By User\n")
            dlg.Destroy()
            return

        dlg.Destroy()
        self.log.write("OnPageClosing: Deleted Page With Small Closing X\n")
        
        event.Skip()        


    def OnDnD(self, event):

        old = event.GetOldPosition()
        new = event.GetNewPosition()

        # Show How To Veto DnD On ScrolledWindow Tab
        if self.nb.GetPageText(old) == "ScrolledWindow":
            self.log.write("OnPageDnD: Tab 'ScrolledWindow' Can Not Be Moved ;-)\n")
            return
        
        self.log.write("OnPageDnD: Old:%d, New:%d\n" % (old, new))

        event.Skip()        


    def OnLeftDClick(self, event):

        nPage = event.GetSelection()
        self.log.write("OnLeftDClick: Got Mouse Left Double Click On Page: " + str(nPage) + "\n")

        if self.enablerep.GetValue() == 1:
            if self.framerep.GetValue() == 1:
                self.nb.ReparentToFrame(nPage, False)
            else:
                self.nb.ReparentToFrame(nPage, True)
        
        event.Skip()


    def OnRight(self, event):

        nPage = event.GetSelection()
        self.log.write("OnRight: Got Mouse Right Click On Page: " + str(nPage) + "\n")
        event.Skip()


    def OnMiddle(self, event):

        nPage = event.GetSelection()
        self.log.write("OnMiddle: Got Mouse Middle Click On Page: " + str(nPage) + "\n")
        event.Skip()
        

    def CreateMenuBar(self):

        file_menu = wx.Menu()
        
        AS_EXIT = wx.NewId()        
        file_menu.Append(AS_EXIT, "&Exit")
        self.Bind(wx.EVT_MENU, self.OnClose, id=AS_EXIT)

        help_menu = wx.Menu()

        AS_ABOUT = wx.NewId()        
        help_menu.Append(AS_ABOUT, "&About...")
        self.Bind(wx.EVT_MENU, self.OnAbout, id=AS_ABOUT)

        menu_bar = wx.MenuBar()

        menu_bar.Append(file_menu, "&File")
        menu_bar.Append(help_menu, "&Help")        

        return menu_bar        


    def OnClose(self, event):
        
        self.Destroy()


    def OnAbout(self, event):

        msg = "This Is The About Dialog Of The NotebookCtrl Demo.\n\n" + \
              "Author: Andrea Gavana @ 11 Nov 2005\n\n" + \
              "A Load Of Thanks Goes To Julianne Sharer That Has\n" + \
              "Implemented A Lot Of New Features And Refactored This Widget.\n\n" + \
              "Please Report Any Bug/Requests Of Improvements\n" + \
              "To Me At The Following Adresses:\n\n" + \
              "andrea.gavana@agip.it\n" + "andrea_gavana@tin.it\n\n" + \
              "Welcome To wxPython " + wx.VERSION_STRING + "!!"
              
        dlg = wx.MessageDialog(self, msg, "NotebookCtrl Demo",
                               wx.OK | wx.ICON_INFORMATION)

        if wx.Platform != '__WXMAC__':
            dlg.SetFont(wx.Font(8, wx.NORMAL, wx.NORMAL, wx.NORMAL, False))
            
        dlg.ShowModal()
        dlg.Destroy()
        

    def CreatePopupMenus(self):

        if self.nb.GetPageCount() == 0:
            return

        if not hasattr(self, "popupID1"):
            self.popupID1 = wx.NewId()
            self.popupID2 = wx.NewId()
            self.popupID3 = wx.NewId()
            self.popupID4 = wx.NewId()
            self.popupID5 = wx.NewId()
            self.popupID6 = wx.NewId()
            self.popupID7 = wx.NewId()
            self.popupID8 = wx.NewId()
            self.popupID9 = wx.NewId()
            self.popupID10 = wx.NewId()
            self.popupID11 = wx.NewId()
            self.popupID12 = wx.NewId()

            self.Bind(wx.EVT_MENU, self.OnPopupOne, id=self.popupID1)
            self.Bind(wx.EVT_MENU, self.OnPopupTwo, id=self.popupID2)
            self.Bind(wx.EVT_MENU, self.OnPopupThree, id=self.popupID3)
            self.Bind(wx.EVT_MENU, self.OnPopupFour, id=self.popupID4)
            self.Bind(wx.EVT_MENU, self.OnPopupFive, id=self.popupID5)
            self.Bind(wx.EVT_MENU, self.OnPopupSix, id=self.popupID6)
            self.Bind(wx.EVT_MENU, self.OnPopupSeven, id=self.popupID7)
            self.Bind(wx.EVT_MENU, self.OnPopupEight, id=self.popupID8)
            self.Bind(wx.EVT_MENU, self.OnPopupNine, id=self.popupID9)
            self.Bind(wx.EVT_MENU, self.OnPopupTen, id=self.popupID10)
            self.Bind(wx.EVT_MENU, self.OnPopupEleven, id=self.popupID11)
            self.Bind(wx.EVT_MENU, self.OnPopupTwelve, id=self.popupID12)
            
            
        menu = wx.Menu()
        item = wx.MenuItem(menu, self.popupID1, "One")
        randimage = random.randint(0, len(ArtIDs) - 1)
        bmp = wx.ArtProvider_GetBitmap(eval(ArtIDs[randimage]), wx.ART_TOOLBAR, (16,16))
        item.SetBitmap(bmp)
        menu.AppendItem(item)
        
        # add some other items
        menu.Append(self.popupID2, "Two")
        menu.Append(self.popupID3, "Three")
        menu.Append(self.popupID4, "Four")
        menu.Append(self.popupID5, "Five")
        menu.Append(self.popupID6, "Six")
        # make a submenu
        sm = wx.Menu()
        sm.Append(self.popupID8, "Sub Item 1")
        sm.Append(self.popupID9, "Sub Item 1")
        menu.AppendMenu(self.popupID7, "Test Submenu", sm)

        self.nb.SetPagePopupMenu(0, menu)

        if self.nb.GetPageCount() < 3:
            return
        
        menu = wx.Menu()

        item = wx.MenuItem(menu, self.popupID10, "Close Page")
        bmp = wx.ArtProvider_GetBitmap(wx.ART_DELETE, wx.ART_TOOLBAR, (16,16))
        item.SetBitmap(bmp)
        menu.AppendItem(item)
 
        item = wx.MenuItem(menu, self.popupID11, "Disable Page")
            
        bmp = wx.ArtProvider_GetBitmap(wx.ART_QUIT, wx.ART_TOOLBAR, (16,16))
        item.SetBitmap(bmp)
        menu.AppendItem(item)

        self.nb.SetPagePopupMenu(2, menu)

        if self.nb.GetPageCount() < 5:
            return
        
        menu = wx.Menu()

        item = wx.MenuItem(menu, self.popupID12, "Show About Dialog")
        bmp = wx.ArtProvider_GetBitmap(wx.ART_INFORMATION, wx.ART_TOOLBAR, (16,16))
        item.SetBitmap(bmp)
        menu.AppendItem(item)

        self.nb.SetPagePopupMenu(4, menu)
        

    def OnPopupOne(self, event):
        self.log.write("OnPopupMenu: Popup One\n")


    def OnPopupTwo(self, event):
        self.log.write("OnPopupMenu: Popup Two\n")


    def OnPopupThree(self, event):
        self.log.write("OnPopupMenu: Popup Three\n")


    def OnPopupFour(self, event):
        self.log.write("OnPopupMenu: Popup Four\n")


    def OnPopupFive(self, event):
        self.log.write("OnPopupMenu: Popup Five\n")


    def OnPopupSix(self, event):
        self.log.write("OnPopupMenu: Popup Six\n")


    def OnPopupSeven(self, event):
        self.log.write("OnPopupMenu: Popup Seven\n")


    def OnPopupEight(self, event):
        self.log.write("OnPopupMenu: Popup Eight\n")


    def OnPopupNine(self, event):
        self.log.write("OnPopupMenu: Popup Nine\n")        


    def OnPopupTen(self, event):

        msg = "Are You Sure You Want To Close This Page?"
        dlg = wx.MessageDialog(self, msg, "NotebookCtrl Question",
                               wx.YES_NO | wx.NO_DEFAULT | wx.CANCEL | wx.ICON_QUESTION)

        if wx.Platform != '__WXMAC__':
            dlg.SetFont(wx.Font(8, wx.NORMAL, wx.NORMAL, wx.NORMAL, False))
        
        if dlg.ShowModal() in [wx.ID_NO, wx.ID_CANCEL]:
            self.log.write("OnPopupMenu: Closing Event Blocked By User\n")
            dlg.Destroy()
            return

        dlg.Destroy()

        self.nb.DeletePage(2)        
        self.log.write("OnPopupMenu: Deleted Page By Popup Menu\n")
        
        event.Skip()        


    def OnPopupEleven(self, event):

        if self.nb.IsPageEnabled(2):
            self.nb.EnablePage(2, False)
            self.log.write("OnPopupMenu: Page 2 Disabled With Menu\n")
        

    def OnPopupTwelve(self, event):

        self.log.write("OnPopupMenu: About Dialog Called With Menu\n")
        self.OnAbout(None)
        

class MyLog(wx.PyLog):
    
    def __init__(self, textCtrl):
        
        wx.PyLog.__init__(self)
        self.tc = textCtrl

    def DoLogString(self, message):
        if self.tc:
            self.tc.AppendText(message + '\n')
            

class TestNotebookCtrl(NC.NotebookCtrl):
    
    def __init__(self, parent, id, style, nbsizer):
        
        NC.NotebookCtrl.__init__(self, parent, id, pos=wx.DefaultPosition,
                                 size=DEFAULT_SIZE, style=style, sizer=nbsizer)

        win = self.makeColorPanel(wx.BLUE)
        self.AddPage(win, "Blue")
        st = wx.StaticText(win.win, -1,
                          "You Can Put Nearly Any Type Of Window Here,\n"
                          "And Tabs Can Be At The Top Or At The Bottom\n"
                          "Of The NotebookCtrl.",
                          (10, 10))

        st.SetForegroundColour(wx.WHITE)
        st.SetBackgroundColour(wx.BLUE)

        # Show how to put an image on one of the notebook tabs,
        # first make the image list:
        self.il = wx.ImageList(16, 16)

        # Add The Images To The Image List
        for items in ArtIDs:
            bmp = wx.ArtProvider_GetBitmap(eval(items), wx.ART_TOOLBAR, (16,16))
            self.il.Add(bmp)

        self.il.Add(GetSmilesBitmap())
        self.AssignImageList(self.il)

        win = self.makeColorPanel(wx.RED)
        self.AddPage(win, "Red")

        win = ScrolledWindow.MyCanvas(self)
        self.AddPage(win, 'ScrolledWindow')

        win = self.makeColorPanel(wx.GREEN)
        self.AddPage(win, "Green")

        win = GridSimple.SimpleGrid(self, None)
        self.AddPage(win, "Grid")

        win = ListCtrl.TestListCtrlPanel(self, None)
        self.AddPage(win, 'List')

        win = self.makeColorPanel(wx.CYAN)
        self.AddPage(win, "Cyan")

        win = self.makeColorPanel(wx.NamedColour('MIDNIGHT BLUE'))
        self.AddPage(win, "MIDNIGHT BLUE")

        win = self.makeColorPanel(wx.NamedColour('INDIAN RED'))
        self.AddPage(win, "INDIAN RED")

        
    def makeColorPanel(self, color):
        
        p = wx.Panel(self, -1)
        win = ColorPanel.ColoredPanel(p, color)
        p.win = win

        def OnCPSize(evt, win=win):
            win.SetSize(evt.GetSize())

        p.Bind(wx.EVT_SIZE, OnCPSize)
        return p


class HTMLPanel(wx.Panel):

    def __init__(self, parent, id=-1, pos=wx.DefaultPosition, size=wx.DefaultSize,
                 style=wx.CLIP_CHILDREN):

        wx.Panel.__init__(self, parent, id, pos, size, style)
        self.ovr = wx.html.HtmlWindow(self, -1, size=(400, 400))

        def OnOvrSize(evt, ovr=self.ovr):
            ovr.SetSize(evt.GetSize())

        def EmptyHandler(evt):
            pass
        
        self.Bind(wx.EVT_SIZE, OnOvrSize)
        self.Bind(wx.EVT_ERASE_BACKGROUND, EmptyHandler)

        if "gtk2" in wx.PlatformInfo:
            self.ovr.SetStandardFonts()
            
        text = htmlhelp
        text = '<br>'.join(text.split('\n'))
            
        if wx.USE_UNICODE:
            text = text.decode('iso8859_1')
            
        self.ovr.SetPage(text)

        
class LogoPanel(wx.Panel):

    def __init__(self, parent, id=-1, pos=wx.DefaultPosition, size=wx.DefaultSize,
                 style=wx.CLIP_CHILDREN):

        wx.Panel.__init__(self, parent, id, pos, size, style)
        self.SetBackgroundColour("WHITE")
        self.bmp = wx.Image("davinci_notebook.jpg", wx.BITMAP_TYPE_JPEG)
        self.bmp2 = self.bmp.ConvertToBitmap()

        self.bigfont = wx.Font(18, wx.SWISS, wx.NORMAL, wx.BOLD, False)
        self.normalfont = wx.Font(14, wx.SWISS, wx.NORMAL, wx.BOLD, True)
        
        self.Bind(wx.EVT_PAINT, self.OnPaint)
        self.Bind(wx.EVT_SIZE, self.OnSize)


    def OnSize(self, event):

        self.xbmp, self.ybmp = self.GetSize()
        self.bmp2 = self.bmp.Scale(self.xbmp, self.ybmp)
        self.bmp2 = self.bmp2.ConvertToBitmap()
        self.Refresh()
        event.Skip()
        

    def OnPaint(self, event):
        
        dc = wx.PaintDC(self)
        self.PrepareDC(dc)
        self.DoDrawing(dc)    

        event.Skip()
        

    def DoDrawing(self, dc):
        
        dc.BeginDrawing()

        dc.DrawBitmap(self.bmp2, 0, 0, True)        
        dc.SetFont(self.bigfont)
        dc.SetTextForeground(wx.BLUE)
        dc.SetBrush(wx.TRANSPARENT_BRUSH)
        dc.SetPen(wx.Pen(wx.BLUE, 2))
        w, h = dc.GetTextExtent("NotebookCtrl")
        xpos = (self.xbmp - w)/2
        ypos = self.ybmp/3
        dc.DrawRoundedRectangle(xpos-5, ypos-3, w+10, h+6, 3)
        dc.DrawText("NotebookCtrl", xpos, ypos)
        dc.SetFont(self.normalfont)
        dc.SetTextForeground(wx.RED)
        w, h = dc.GetTextExtent("Andrea Gavana")
        xpos = (self.xbmp - w)/2
        ypos = 2*self.ybmp/3
        dc.DrawText("Andrea Gavana", xpos, ypos)
        w, h = dc.GetTextExtent("16 Dec 2005")
        xpos = (self.xbmp - w)/2
        ypos = 2*self.ybmp/3 + 3*h/2
        dc.DrawText("16 Dec 2005", xpos, ypos)
        
        dc.EndDrawing()       

        
def main():

    app = wx.PySimpleApp()
    frame = NotebookCtrlDemo(None, -1, "NotebookCtrl Demo ;-)", size=(680, 480))
    frame.CenterOnScreen()
    frame.Show()
    
    app.MainLoop()

    
if __name__ == "__main__":
    main()

    
        
    
     